#include <stdlib.h>
#include <time.h>
#include <iostream>
using namespace std;
// -----------------------------------------------------------------------------

#include "hchain.h"
#include "hopen.h"
// -----------------------------------------------------------------------------

int idealmod = 512;     // obliczamy jako valCount/srednia_dlugosc_listy
int calcmod = 761;      // obliczamy przy pomocy programu ./fus
int a = 11;
int b = 101;
int p = 10007;          // obliczamy uzywajac programu ./fnp
int m = calcmod;
// -----------------------------------------------------------------------------

int hashf1(int __val)
{
    return __val % idealmod;
}
// -----------------------------------------------------------------------------

int hashf2(int __val)
{
    return __val % calcmod;
}
// -----------------------------------------------------------------------------

int hashf3(int __val)
{
    return ((a*__val + b) % p) % m;
}
// -----------------------------------------------------------------------------

int openhash1(int __val, int i)
{
    return (20*__val + 7*i)%400;
}
// -----------------------------------------------------------------------------

int openhash2(int __val, int i)
{
    return (__val + 3*i)%20;
}
// -----------------------------------------------------------------------------

int openhash3(int __val, int i)
{
    return (3*__val + 17*i*i + 15*i)%20;
}
// -----------------------------------------------------------------------------

int main(void)
{
    srand(time(NULL));

    int valCount = 3584;
    int maxVal = 10000;

    hash_chain hc1(idealmod, hashf1);
    hash_chain hc2(calcmod, hashf2);
    hash_chain hc3(calcmod, hashf3);
    hash_open ho1(400, openhash1);
    hash_open ho2(20, openhash2);

    for(int i=0;i<valCount;i++)
    {
        int toin = rand()%maxVal;
        hc1.insert(toin);
        hc2.insert(toin);
	hc3.insert(toin);
        ho1.insert(toin);
    }
    /*cout << "---------------------------------------------\n";
    hc1.printValues();
    hc1.printInfo();
    cout << "---------------------------------------------\n";
    //hc2.printValues();
    hc2.printInfo();
    cout << "---------------------------------------------\n";
    //hc3.printValues();
    hc3.printInfo();
    cout << "---------------------------------------------\n";*/
    ho1.printValues();
    ho1.printInfo();
    cout << "---------------------------------------------\n";
    for(int i=0;i<10;i++)
        if(!ho2.insert(20*i))
            cout << "Unable to insert " << 20*i << endl;
            ho2.printValues();

    return 0;
}
// -----------------------------------------------------------------------------
